import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
import "ChatPlus.dictionary";
import "ChatPlus.names";
import "ChatPlus.languages";

import "ChatPlus.codes";


hexstrtonum = function(hex)
	hex=string.lower(hex)
	local hexstr = '0123456789abcdef'
	local s=0
	for i = 0,(#hex)-1 do
		for j =1,#hexstr do
			if hex:sub(#hex-i,#hex-i) == hexstr:sub(j,j) then
				s=s+(math.pow(16,i)*(j-1))
			end
		end
	end
	return s
end

optionsWindow=Turbine.UI.Lotro.Window()
optionsWindow:SetText(strings["Settings"][lang])
optionsWindow:SetSize(700,700)
optionsWindow:SetPosition(Turbine.UI.Display:GetWidth()/2-350,Turbine.UI.Display:GetHeight()/2-350)



selectedOptionsHeading=nil

optionsWindow.ChanListBox=Turbine.UI.ListBox()
optionsWindow.ChanListBox:SetParent(optionsWindow)
--optionsWindow.ChanListBox:SetBackColor(Turbine.UI.Color(0,0.2,0.2,0.2))
optionsWindow.ChanListBox:SetPosition(50,40)
optionsWindow.ChanListBox:SetSize(600,30)
optionsWindow.ChanListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
optionsWindow.ChanListBox:SetBackColor(Turbine.UI.Color(0.95,0.5,0.5,0.5));

optionsWindow.SettingsListBox=Turbine.UI.ListBox()
optionsWindow.SettingsListBox:SetParent(optionsWindow)
optionsWindow.SettingsListBox:SetPosition(50,80)
optionsWindow.SettingsListBox:SetSize(600,570)
optionsWindow.SettingsListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
optionsWindow.SettingsListBox:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));

populateOptionsHeadings = function()
	local counter = 1
	for i = 1,#strings["menuItems"][lang] do
		local listItem = Turbine.UI.Button()

		--print(i)
		listItem:SetText(strings["menuItems"][lang][i]);
		listItem:SetFont(Verdana10)
		listItem:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
		listItem:SetSize(600/#strings["menuItems"][lang] , 30 );
		--listItem:SetBlendMode(Turbine.UI.BlendMode.Overlay);

		if i== selectedOptionsHeading then
			listItem:SetBackColor(Turbine.UI.Color(0.9,0.2,0.2,0.8));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.9,0.2,0.2,0.8));
			end

		else
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			end

	
			--listItem:SetBackground(imageCodes[counter]);
			--listItem:SetSize(284,90)
			--listItem:SetStretchMode(1)
			--listItem:SetSize(((SmallWindow:GetWidth()+2)/mainChannelsN)-2, 25 );
		end
		listItem.MouseEnter=function()
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.5));
		end
		listItem.MouseDown=function()
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.9));
		end
		listItem.MouseUp=function()
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.7));
		end

		--loadstring(listItem.string.gsub(i,%s,""):SetSize();
		counter=counter+1
		listItem.index=i
	
	
		optionsWindow.ChanListBox:AddItem(listItem);
		local item= Turbine.UI.Control();
	
		item:SetSize(2, 30 );
		item:SetBackColor(Turbine.UI.Color(0.95,0.5,0.5,0.5));
		optionsWindow.ChanListBox:AddItem( item );

	
	end
end
populateOptionsHeadings()
function optionsWindow.ChanListBox:SelectedIndexChanged(sender, args)
	selectedOptionsHeading=optionsWindow.ChanListBox:GetSelectedItem()["index"] 
	optionChanged()
end

function optionChanged()
	
	optionsWindow.ChanListBox:ClearItems()
	populateOptionsHeadings()
	optionsWindow.SettingsListBox:ClearItems()
	if selectedOptionsHeading == 1 then
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------auto renaming---------------
		horListBox:SetSize(600,20)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local label=Turbine.UI.Label()
		label:SetSize(550,19)
		label:SetText(strings["Auto"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)
		local check = Turbine.UI.Lotro.CheckBox()
		check:SetSize(19,19)
		if data["Options"]["autoRenaming"] ~= nil then
			check:SetChecked(data["Options"]["autoRenaming"])

		else
			check:SetChecked(true)

		end

		function check.CheckedChanged(sender, args)
			data["Options"]["autoRenaming"]=check:IsChecked()


			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end
		horListBox:AddItem(check)


		local horListBox= Turbine.UI.ListBox()  ----------------------------------------minimum letters---------------
		horListBox:SetSize(600,22)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		--horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);


		local label=Turbine.UI.Label()
		label:SetSize(548,22)
		label:SetText(strings["Min"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)

		local entry = Turbine.UI.TextBox()
		entry:SetSelectable(true);
		entry:SetSize(20,22)
		entry:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
		if data["Options"]["minimumLetters"] ~= nil then
			entry:SetText(data["Options"]["minimumLetters"])
		else
			entry:SetText("5")
		end
		function entry.TextChanged(sender,args)
			local entryText=entry:GetText()
			entryText=string.gsub(entryText,"%D","")
			entry:SetText(entryText)
			data["Options"]["minimumLetters"]=entryText
			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end

		horListBox:AddItem(entry)
		local startPosition=1
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------replacements/bans---------------
		horListBox:SetSize(600,530)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local vertListBox= Turbine.UI.ListBox()  ----------------------------------------replacements---------------
		vertListBox:SetSize(290,530)
		vertListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		vertListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		horListBox:AddItem(vertListBox);
		local repScrollBar=Turbine.UI.Lotro.ScrollBar()
		repScrollBar:SetSize(10,530)
		repScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		repScrollBar.ValueChanged=function()
			startPosition=repScrollBar:GetValue()
			replacements()
		end
		horListBox:AddItem(repScrollBar);

		function replacements()
			vertListBox:ClearItems()
			local label =Turbine.UI.Label()
			label:SetSize(100,22)
			label:SetMarkupEnabled(true)
			label:SetText("<u>"..strings["Names"][lang].."</u>")
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			vertListBox:AddItem(label)

			local count = 1
			for i in pairs(data["Replacements"]) do
				local item = Turbine.UI.ListBox() 
				item:SetSize(290,22)
				item:SetOrientation( Turbine.UI.Orientation.Horizontal )
				if count % 2 ~=0 then
					item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
				end
				count=count+1				
				if count > startPosition then
					vertListBox:AddItem(item);
				end
				local label =Turbine.UI.Label()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(100,22)
				label:SetText(i)
				item:AddItem(label)
				local label =Turbine.UI.Label()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(30,22)
				label:SetText("->")
				item:AddItem(label)
				local label =Turbine.UI.TextBox()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(115,22)
				label:SetText(data["Replacements"][i])
				label:SetSelectable(true);
				item:AddItem(label)
				function label.TextChanged(sender,args)
					data["Replacements"][i]=label:GetText()
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				end
				local label =Turbine.UI.Control()

				label:SetSize(22,22)
				label:SetBackground(0x41139ed5)
				item:AddItem(label)
				function label.MouseClick(sender,args)
					data["Replacements"][i]=randomName({})
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					replacements()
				end
				local label =Turbine.UI.Button()
				item:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				label:SetBackground(0x4110f400)
				label:SetSize(22,22)

				
				
				item:AddItem(label)

				function label.MouseEnter(sender,args)
					label:SetBackground(0x4110f3fe)
				end
				function label.MouseLeave(sender,args)
					label:SetBackground(0x4110f400)
				end
				function label.MouseDown(sender,args)
					label:SetBackground(0x4110f3ff)
				end
				function label.MouseUp(sender,args)
					label:SetBackground(0x4110f3fe)
				end




				function label.MouseClick(sender,args)
					data["Replacements"][i]=nil
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					replacements()
				end





			end
			local item = Turbine.UI.ListBox() 
			item:SetSize(290,22)
			item:SetOrientation( Turbine.UI.Orientation.Horizontal )
			if count % 2 ~=0 then
				item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
			end
			vertListBox:AddItem(item)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(50,22)
			label:SetText(strings["New"][lang]..": ")
			item:AddItem(label)
			local fromName =Turbine.UI.Lotro.TextBox()
			fromName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			fromName:SetSize(50,22)
			item:AddItem(fromName)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(30,22)
			label:SetText(" ->")
			item:AddItem(label)

			local toName =Turbine.UI.Lotro.TextBox()
			toName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			toName:SetSize(50,22)
			item:AddItem(toName)

			local label =Turbine.UI.Label()
			--label:SetBackColor(Turbine.UI.Color(0.95,0.2,0.2,0.2));
			label:SetText("")
			label:SetSize(5,22)

			item:AddItem(label)

			local listItem=Turbine.UI.Button()
			listItem:SetText(strings["Add"][lang])
			listItem:SetSize(40,22)
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			end
			listItem.MouseEnter=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.5));
			end
			listItem.MouseDown=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.9));
			end
			listItem.MouseUp=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.7));
			end
			listItem.MouseClick=function()
				data["Replacements"][fromName:GetText()]=toName:GetText()
				Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				fromName:SetText("")
				toName:SetText("")
				replacements()
			end
			item:AddItem(listItem)















			repScrollBar:SetMaximum(count)
		end
		replacements()


		local vertListBox= Turbine.UI.ListBox()  ----------------------------------------bans---------------
		vertListBox:SetSize(290,530)
		startPosition2=1
		vertListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		vertListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		horListBox:AddItem(vertListBox);
		local repScrollBar=Turbine.UI.Lotro.ScrollBar()
		repScrollBar:SetSize(10,530)
		repScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		repScrollBar.ValueChanged=function()
			startPosition2=repScrollBar:GetValue()
			replacements()
		end
		horListBox:AddItem(repScrollBar);

		function bans()
			vertListBox:ClearItems()
			local label =Turbine.UI.Label()
			label:SetSize(100,22)
			label:SetMarkupEnabled(true)
			label:SetText("<u>"..strings["Allowed/Banned"][lang].."</u>")
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			vertListBox:AddItem(label)

			local count = 1
			for i in pairs(data["Allowed"]) do
				local item = Turbine.UI.ListBox() 
				item:SetSize(290,22)
				item:SetOrientation( Turbine.UI.Orientation.Horizontal )
				if count % 2 ~=0 then
					item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
				end
				count=count+1				
				if count > startPosition2 then
					vertListBox:AddItem(item);
				end
				local label =Turbine.UI.Label()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(242,22)
				label:SetText(i)
				item:AddItem(label)
				local label =Turbine.UI.Control()
				label:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				--label:SetSize(24,32)
				if data["Allowed"][i] == true then
					label:SetBackground(0x411195ea)
				else
					label:SetBackground(0x411195eb)
				end

				--label:SetStretchMode(1)
				label:SetSize(22,22)
				function label.MouseClick(sender,args)
					data["Allowed"][i]=not data["Allowed"][i]
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					bans()
				end

				item:AddItem(label)
				local label =Turbine.UI.Button()
				item:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				label:SetBackground(0x4110f400)
				label:SetSize(22,22)

				
				
				item:AddItem(label)

				function label.MouseEnter(sender,args)
					label:SetBackground(0x4110f3fe)
				end
				function label.MouseLeave(sender,args)
					label:SetBackground(0x4110f400)
				end
				function label.MouseDown(sender,args)
					label:SetBackground(0x4110f3ff)
				end
				function label.MouseUp(sender,args)
					label:SetBackground(0x4110f3fe)
				end




				function label.MouseClick(sender,args)
					data["Allowed"][i]=nil
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					bans()
				end






			end
			local item = Turbine.UI.ListBox() 
			item:SetSize(290,22)
			item:SetOrientation( Turbine.UI.Orientation.Horizontal )
			if count % 2 ~=0 then
				item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
			end
			vertListBox:AddItem(item)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(50,22)
			label:SetText(strings['New'][lang]..": ")
			item:AddItem(label)
			local fromName =Turbine.UI.Lotro.TextBox()
			fromName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			fromName:SetSize(50,22)
			item:AddItem(fromName)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(30,22)
			label:SetText("")
			item:AddItem(label)

			local typelabel =Turbine.UI.Control()
			typelabel:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			typelabel:SetSize(22,22)
			typelabel:SetBackground(0x411195ea)
			local type = true
			function typelabel.MouseClick(sender,args)
				type=not type

				if type == true then
					typelabel:SetBackground(0x411195ea)
				else
					typelabel:SetBackground(0x411195eb)
				end
			end
			item:AddItem(typelabel)


			local label =Turbine.UI.Label()
			--label:SetBackColor(Turbine.UI.Color(0.95,0.2,0.2,0.2));
			label:SetText("")
			label:SetSize(5,22)

			item:AddItem(label)

			local listItem=Turbine.UI.Button()
			listItem:SetText(strings["Add"][lang])
			listItem:SetSize(40,22)
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			end
			listItem.MouseEnter=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.5));
			end
			listItem.MouseDown=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.9));
			end
			listItem.MouseUp=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.7));
			end
			listItem.MouseClick=function()
				data["Allowed"][fromName:GetText()]=type
				Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				fromName:SetText("")
				bans()
			end
			item:AddItem(listItem)













			repScrollBar:SetMaximum(count)
		end
		bans()


		


		





	elseif selectedOptionsHeading == 2 then
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------channels/notifications---------------
		horListBox:SetSize(600,570)
		startPosition=1
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local vertListBox= Turbine.UI.ListBox()  ----------------------------------------channels---------------
		vertListBox:SetSize(290,570)
		vertListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		vertListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		horListBox:AddItem(vertListBox);
		local repScrollBar=Turbine.UI.Lotro.ScrollBar()
		repScrollBar:SetSize(10,570)
		repScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		repScrollBar.ValueChanged=function()
			startPosition=repScrollBar:GetValue()
			chans()
		end
		horListBox:AddItem(repScrollBar);
		local selectedChan = "38"
		function chans()
			vertListBox:ClearItems()
			local label =Turbine.UI.Label()
			label:SetSize(100,22)
			label:SetMarkupEnabled(true)
			label:SetText("<u>"..strings["Channels"][lang].."</u>")
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			vertListBox:AddItem(label)

			local count = 1
			for i in pairs(chatCodes) do

				local hlist= Turbine.UI.ListBox()  ----------------------------------------channels---------------
				hlist:SetSize(290,22)
				hlist:SetOrientation( Turbine.UI.Orientation.Horizontal )




				local item = Turbine.UI.Label() 
				item:SetSize(150,22)
				item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				if strings[chatCodes[i]]==nil then
					item:SetText(chatCodes[i])
				else
					item:SetText(strings[chatCodes[i]][lang])
				end
				hlist:AddItem(item)

				local colourBlock= Turbine.UI.Control()
				local blockColour = nil
				if colourCodes[data["Colours"][i]["1"]] ~= nil then
					blockColour = colourCodes[data["Colours"][i]["1"]]
				else
					blockColour = data["Colours"][i]["1"]
				end
				--print(data["Colours"][i]["1"])
				---print(colourCodes[data["Colours"][i]["1"]]) 
				--print(hexstrtonum(string.sub(blockColour,3,4))/255)
				colourBlock:SetBackColor(Turbine.UI.Color(1,hexstrtonum(string.sub(blockColour,3,4))/255,hexstrtonum(string.sub(blockColour,5,6))/255,hexstrtonum(string.sub(blockColour,7,8))/255))
				colourBlock:SetSize(30,22)
				colourBlock.MouseClick=function()
					local new=nil
					for j in pairs(colourCodes) do
						if new==true then
							data["Colours"][i]["1"] = j
							new=false
							Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

						elseif colourCodes[j] == blockColour then
							new=true
						end
					
					end
					if new == true then
						for j in pairs(colourCodes) do
							if new==true then
								data["Colours"][i]["1"] = j
								new=false
								Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);

							elseif colourCodes[j] == blockColour then
								new=true
							end
						end
					
					
					elseif new == nil then
						data["Colours"][i]["1"] = "White"
						Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					end


					chans()
				end
				hlist:AddItem(colourBlock)
				local hextext=Turbine.UI.TextBox()
				hextext:SetSelectable(true)
				hextext:SetText(string.sub(blockColour,3,#blockColour))
				hextext:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				hextext:SetSize(50,22)
				function hextext.TextChanged(sender,args)
					local text=hextext:GetText()
					text=string.gsub(text,"%X","")
					hextext:SetText(text)
					if #text == 6 then
						data["Colours"][i]["1"]="0x"..text
						Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
						chans()
					end
				end
				hlist:AddItem(hextext)



				local label =Turbine.UI.Label()
				label:SetText("")
				label:SetSize(30,22)

				hlist:AddItem(label)




				local check = Turbine.UI.Lotro.CheckBox()
				check:SetSize(19,19)
				if data["Colours"][i]["2"] ~= nil then
					check:SetChecked(data["Colours"][i]["2"])

				else
					check:SetChecked(true)

				end

				function check.CheckedChanged(sender, args)
					data["Colours"][i]["2"]=check:IsChecked()

	
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				end
				hlist:AddItem(check)
				if selectedChan == i then
					hlist:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.8));
				elseif count % 2 == 0 then
					hlist:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
				else
					hlist:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
				end





				count=count+1				
				if count > startPosition then
					vertListBox:AddItem(hlist);
					hlist.index=tostring(i)

				end
			end
			vertListBox.SelectedIndexChanged=function()
				if selectedChan ~= vertListBox:GetSelectedItem()["index"] then
					selectedChan = vertListBox:GetSelectedItem()["index"]
					nots()
					chans()
				end

			end
			vertListBox.MouseHover=function()

			end













			repScrollBar:SetMaximum(count)
		end
		chans()


		local vertListBox= Turbine.UI.ListBox()  ----------------------------------------nots---------------
		vertListBox:SetSize(290,570)
		startPosition2=1
		vertListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		vertListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		horListBox:AddItem(vertListBox);
		local repScrollBar=Turbine.UI.Lotro.ScrollBar()
		repScrollBar:SetSize(10,570)
		repScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		repScrollBar.ValueChanged=function()
			startPosition2=repScrollBar:GetValue()
			replacements()
		end
		horListBox:AddItem(repScrollBar);

		function nots()
			vertListBox:ClearItems()
			local label =Turbine.UI.Label()
			label:SetSize(100,22)
			label:SetMarkupEnabled(true)
			label:SetText("<u>"..strings["Notifications"][lang].."</u>")
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			vertListBox:AddItem(label)

			local count = 1
			if data["Notifications"][selectedChan] == nil then
				data["Notifications"][selectedChan] = {}
			end
			for i in pairs(data["Notifications"][selectedChan]) do
				local item = Turbine.UI.ListBox() 
				item:SetSize(290,22)
				item:SetOrientation( Turbine.UI.Orientation.Horizontal )
				if count % 2 ~=0 then
					item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
				end
				count=count+1				
				if count > startPosition2 then
					vertListBox:AddItem(item);
				end
				local label =Turbine.UI.Label()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(264,22)
				label:SetText(i)
				item:AddItem(label)


				local label =Turbine.UI.Button()
				item:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				label:SetBackground(0x4110f400)
				label:SetSize(22,22)

				
				
				item:AddItem(label)

				function label.MouseEnter(sender,args)
					label:SetBackground(0x4110f3fe)
				end
				function label.MouseLeave(sender,args)
					label:SetBackground(0x4110f400)
				end
				function label.MouseDown(sender,args)
					label:SetBackground(0x4110f3ff)
				end
				function label.MouseUp(sender,args)
					label:SetBackground(0x4110f3fe)
				end




				function label.MouseClick(sender,args)
					data["Notifications"][selectedChan][i]=nil
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					nots()
				end






			end
			local item = Turbine.UI.ListBox() 
			item:SetSize(290,22)
			item:SetOrientation( Turbine.UI.Orientation.Horizontal )
			if count % 2 ~=0 then
				item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
			end
			vertListBox:AddItem(item)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(50,22)
			label:SetText(strings['New'][lang]..": ")
			item:AddItem(label)
			local fromName =Turbine.UI.Lotro.TextBox()
			fromName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			fromName:SetSize(50,22)
			item:AddItem(fromName)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(30,22)
			label:SetText("")
			item:AddItem(label)



			local label =Turbine.UI.Label()
			--label:SetBackColor(Turbine.UI.Color(0.95,0.2,0.2,0.2));
			label:SetText("")
			label:SetSize(5,22)

			item:AddItem(label)

			local listItem=Turbine.UI.Button()
			listItem:SetText(strings["Add"][lang])
			listItem:SetSize(40,22)
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			end
			listItem.MouseEnter=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.5));
			end
			listItem.MouseDown=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.9));
			end
			listItem.MouseUp=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.7));
			end
			listItem.MouseClick=function()

				data["Notifications"][selectedChan][fromName:GetText()]=true
				Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				fromName:SetText("")
				nots()
			end
			item:AddItem(listItem)














			repScrollBar:SetMaximum(count)
		end
		nots()


		


		



	elseif selectedOptionsHeading == 3 then
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------filter colours---------------
		horListBox:SetSize(600,20)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local label=Turbine.UI.Label()
		label:SetSize(550,19)
		label:SetText(strings["customcfilt"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)
		local check = Turbine.UI.Lotro.CheckBox()
		check:SetSize(19,19)
		if data["Options"]["customColours"] ~= nil then
			check:SetChecked(data["Options"]["customColours"])

		else
			check:SetChecked(false)

		end

		function check.CheckedChanged(sender, args)
			data["Options"]["customColours"]=check:IsChecked()


			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end
		horListBox:AddItem(check)


		local horListBox= Turbine.UI.ListBox()  ----------------------------------------filter Underlines---------------
		horListBox:SetSize(600,20)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		--horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local label=Turbine.UI.Label()
		label:SetSize(550,19)
		label:SetText(strings["customufilt"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)
		local check = Turbine.UI.Lotro.CheckBox()
		check:SetSize(19,19)
		if data["Options"]["customColours"] ~= nil then
			check:SetChecked(data["Options"]["customUnderlines"])

		else
			check:SetChecked(false)

		end

		function check.CheckedChanged(sender, args)
			data["Options"]["customUnderlines"]=check:IsChecked()


			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end
		horListBox:AddItem(check)





		local startPosition=1
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------filters---------------
		horListBox:SetSize(600,530)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local vertListBox= Turbine.UI.ListBox()  ----------------------------------------filters---------------
		vertListBox:SetSize(590,530)
		vertListBox:SetOrientation( Turbine.UI.Orientation.Vertical )
		vertListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		horListBox:AddItem(vertListBox);
		local repScrollBar=Turbine.UI.Lotro.ScrollBar()
		repScrollBar:SetSize(10,530)
		repScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical )
		repScrollBar.ValueChanged=function()
			startPosition=repScrollBar:GetValue()
			replacements()
		end
		horListBox:AddItem(repScrollBar);

		function filts()
			vertListBox:ClearItems()
			local label =Turbine.UI.Label()
			label:SetSize(200,22)
			label:SetMarkupEnabled(true)
			label:SetText("<u>"..strings["filters"][lang].."</u>")
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			vertListBox:AddItem(label)

			local count = 1
			if data["Filters"] == nil then
				data["Filters"]={}
			end
			for i in pairs(data["Filters"]) do
				local item = Turbine.UI.ListBox() 
				item:SetSize(590,22)
				item:SetOrientation( Turbine.UI.Orientation.Horizontal )
				if count % 2 ~=0 then
					item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
				end
				count=count+1				
				if count > startPosition then
					vertListBox:AddItem(item);
				end
				local label =Turbine.UI.Label()
				label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
				label:SetSize(540,22)
				label:SetText(i)
				item:AddItem(label)

				local label =Turbine.UI.Button()
				item:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				label:SetBackground(0x4110f400)
				label:SetSize(22,22)

				
				
				item:AddItem(label)

				function label.MouseEnter(sender,args)
					label:SetBackground(0x4110f3fe)
				end
				function label.MouseLeave(sender,args)
					label:SetBackground(0x4110f400)
				end
				function label.MouseDown(sender,args)
					label:SetBackground(0x4110f3ff)
				end
				function label.MouseUp(sender,args)
					label:SetBackground(0x4110f3fe)
				end




				function label.MouseClick(sender,args)
					data["Filters"][i]=nil
					Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
					filts()
				end





			end
			local item = Turbine.UI.ListBox() 
			item:SetSize(590,22)
			item:SetOrientation( Turbine.UI.Orientation.Horizontal )
			if count % 2 ~=0 then
				item:SetBackColor(Turbine.UI.Color(0.995,0.2,0.2,0.2));
			end
			vertListBox:AddItem(item)
			local label =Turbine.UI.Label()
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			label:SetSize(50,22)
			label:SetText(strings["New"][lang]..": ")
			item:AddItem(label)
			local fromName =Turbine.UI.Lotro.TextBox()
			fromName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
			fromName:SetSize(50,22)
			item:AddItem(fromName)


			local label =Turbine.UI.Label()
			--label:SetBackColor(Turbine.UI.Color(0.95,0.2,0.2,0.2));
			label:SetText("")
			label:SetSize(5,22)

			item:AddItem(label)

			local listItem=Turbine.UI.Button()
			listItem:SetText(strings["Add"][lang])
			listItem:SetSize(40,22)
			listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			listItem.MouseLeave=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.1));
			end
			listItem.MouseEnter=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.5));
			end
			listItem.MouseDown=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.9));
			end
			listItem.MouseUp=function()
				listItem:SetBackColor(Turbine.UI.Color(0.95,0.1,0.1,0.7));
			end
			listItem.MouseClick=function()
				data["Filters"][fromName:GetText()]=true
				Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
				fromName:SetText("")

				filts()
			end
			item:AddItem(listItem)















			repScrollBar:SetMaximum(count)
		end
		filts()

	elseif selectedOptionsHeading == 5 then
		local horListBox= Turbine.UI.ListBox()  ----------------------------------------dev mode---------------
		horListBox:SetSize(600,20)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local label=Turbine.UI.Label()
		label:SetSize(550,19)
		label:SetText(strings["devMode"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)
		local check = Turbine.UI.Lotro.CheckBox()
		check:SetSize(19,19)
		if data["Options"]["DevMode"] ~= nil then
			check:SetChecked(data["Options"]["DevMode"])

		else
			check:SetChecked(false)

		end

		function check.CheckedChanged(sender, args)
			data["Options"]["DevMode"]=check:IsChecked()


			Turbine.PluginData.Save(Turbine.DataScope.Character, "ChatPlusData", data);
		end
		horListBox:AddItem(check)

		local horListBox= Turbine.UI.ListBox()  ----------------------------------------s2 chat---------------
		horListBox:SetSize(600,20)
		horListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
		--horListBox:SetBackColor(Turbine.UI.Color(0.995,0.1,0.1,0.1));
		optionsWindow.SettingsListBox:AddItem(horListBox);
		local label=Turbine.UI.Label()
		label:SetSize(550,19)
		label:SetText(strings["stoc"][lang])
		label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
		horListBox:AddItem(label)
		local check = Turbine.UI.Lotro.CheckBox()
		check:SetSize(19,19)
		if off ~= nil then
			check:SetChecked(not off)

		else
			check:SetChecked(true)

		end

		function check.CheckedChanged(sender, args)
			off=not check:IsChecked()


		end
		horListBox:AddItem(check)





	end


		
		
end





	
